Panda3D

Loading...
Searching...
No Matches
Public Member Functions | List of all members
ColorInterpolationSegment Class Reference

A single unit of interpolation. More...

`#include "colorInterpolationManager.h"`

Inheritance diagram for ColorInterpolationSegment:

## Public Member Functions
| ColorInterpolationSegment (ColorInterpolationFunction *function, const PN_stdfloat &time_begin, const PN_stdfloat &time_end, const bool is_modulated, const int id)
| constructor
| ColorInterpolationSegment (const ColorInterpolationSegment &s)
| copy constructor
virtual | ~ColorInterpolationSegment ()
| destructor
TypedReferenceCount * | get_function () const
| Returns a reference to the function object corresponding to this segment.
int | get_id () const
| Returns the id assigned to this segment by the manager that created it.
PN_stdfloat | get_time_begin () const
| Returns the point in the particle's lifetime at which this segment begins its effect.
PN_stdfloat | get_time_end () const
| Returns the point in the particle's lifetime at which this segment's effect stops.
LColor | interpolateColor (const PN_stdfloat t) const
| Returns the interpolated color according to the segment's function and start and end times.
bool | is_enabled () const
| Returns whether the segments effects are being applied.
bool | is_modulated () const
| Returns whether the function is additive or modulated.
void | set_enabled (const bool enabled)
| Sets whether the segments effects should be applied.
void | set_function (ColorInterpolationFunction *function)
| Sets the function that the segment will use for its interpolation calculations.
void | set_is_modulated (const bool flag)
| Sets how the function is applied to the final color.
void | set_time_begin (const PN_stdfloat time)
| Sets the point in the particle's lifetime at which this segment begins its effect.
void | set_time_end (const PN_stdfloat time)
| Sets the point in the particle's lifetime at which this segment's effect ends.
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)

## Additional Inherited Members
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Detailed Description

A single unit of interpolation.

The begin and end times are interpolated over the lifetime of the particle, thus have the range of [0,1]. Each segment also has a function associated with it.

Definition at line 227 of file colorInterpolationManager.h.

## Constructor & Destructor Documentation

## ◆ ColorInterpolationSegment() [1/2]

ColorInterpolationSegment::ColorInterpolationSegment | ( | ColorInterpolationFunction * | function,
|  | const PN_stdfloat & | time_begin,
|  | const PN_stdfloat & | time_end,
|  | const bool | is_modulated,
|  | const int | id )

constructor

Definition at line 170 of file colorInterpolationManager.cxx.

References is_modulated().

Referenced by ColorInterpolationSegment().

## ◆ ColorInterpolationSegment() [2/2]

ColorInterpolationSegment::ColorInterpolationSegment | ( | const ColorInterpolationSegment & | s | ) |

copy constructor

Definition at line 189 of file colorInterpolationManager.cxx.

References ColorInterpolationSegment().

## ◆ ~ColorInterpolationSegment()

ColorInterpolationSegment::~ColorInterpolationSegment | ( |  | ) |
| virtual

destructor

Definition at line 204 of file colorInterpolationManager.cxx.

## Member Function Documentation

## ◆ get_function()

TypedReferenceCount * ColorInterpolationSegment::get_function | ( |  | ) | const
| inline

Returns a reference to the function object corresponding to this segment.

Definition at line 110 of file colorInterpolationManager.I.

## ◆ get_id()

int ColorInterpolationSegment::get_id | ( |  | ) | const
| inline

Returns the id assigned to this segment by the manager that created it.

Definition at line 157 of file colorInterpolationManager.I.

## ◆ get_time_begin()

PN_stdfloat ColorInterpolationSegment::get_time_begin | ( |  | ) | const
| inline

Returns the point in the particle's lifetime at which this segment begins its effect.

It is an interpolated value in the range [0,1].

Definition at line 120 of file colorInterpolationManager.I.

Referenced by ColorInterpolationManager::generateColor().

## ◆ get_time_end()

PN_stdfloat ColorInterpolationSegment::get_time_end | ( |  | ) | const
| inline

Returns the point in the particle's lifetime at which this segment's effect stops.

It is an interpolated value in the range [0,1].

Definition at line 130 of file colorInterpolationManager.I.

## ◆ interpolateColor()

LColor ColorInterpolationSegment::interpolateColor | ( | const PN_stdfloat | t | ) | const

Returns the interpolated color according to the segment's function and start and end times.

't' is a value in [0-1] where corresponds to beginning of the segment and 1 corresponds to the end.

Definition at line 214 of file colorInterpolationManager.cxx.

Referenced by ColorInterpolationManager::generateColor().

## ◆ is_enabled()

bool ColorInterpolationSegment::is_enabled | ( |  | ) | const
| inline

Returns whether the segments effects are being applied.

Definition at line 148 of file colorInterpolationManager.I.

Referenced by ColorInterpolationManager::generateColor().

## ◆ is_modulated()

bool ColorInterpolationSegment::is_modulated | ( |  | ) | const
| inline

Returns whether the function is additive or modulated.

Definition at line 139 of file colorInterpolationManager.I.

Referenced by ColorInterpolationSegment(), and ColorInterpolationManager::generateColor().

## ◆ set_enabled()

void ColorInterpolationSegment::set_enabled | ( | const bool | enabled | ) |
| inline

Sets whether the segments effects should be applied.

Definition at line 208 of file colorInterpolationManager.I.

## ◆ set_function()

void ColorInterpolationSegment::set_function | ( | ColorInterpolationFunction * | function | ) |
| inline

Sets the function that the segment will use for its interpolation calculations.

Definition at line 167 of file colorInterpolationManager.I.

## ◆ set_is_modulated()

void ColorInterpolationSegment::set_is_modulated | ( | const bool | flag | ) |
| inline

Sets how the function is applied to the final color.

If true, the value is multiplied. If false, the value is simply added. Default is true.

Definition at line 199 of file colorInterpolationManager.I.

## ◆ set_time_begin()

void ColorInterpolationSegment::set_time_begin | ( | const PN_stdfloat | time | ) |
| inline

Sets the point in the particle's lifetime at which this segment begins its effect.

It is an interpolated value in the range [0,1].

Definition at line 177 of file colorInterpolationManager.I.

## ◆ set_time_end()

void ColorInterpolationSegment::set_time_end | ( | const PN_stdfloat | time | ) |
| inline

Sets the point in the particle's lifetime at which this segment's effect ends.

It is an interpolated value in the range [0,1].

Definition at line 188 of file colorInterpolationManager.I.

The documentation for this class was generated from the following files:

- panda/src/particlesystem/colorInterpolationManager.h
- panda/src/particlesystem/colorInterpolationManager.cxx
- panda/src/particlesystem/colorInterpolationManager.I